#ifndef FLYFM_NETWORKPLACESMANAGERPROXY_H
#define FLYFM_NETWORKPLACESMANAGERPROXY_H

#include <flyfm/vfs_export.h>

#include <QObject>
#include <QWeakPointer>
#include <QDBusInterface>

#include <flyfm/networkplace.h>

namespace FlyFM
{

class FLYFM_VFS_EXPORT NetworkPlacesManagerProxy : public QObject
{
    Q_OBJECT
public:
    explicit NetworkPlacesManagerProxy(QWeakPointer<QDBusInterface> interface, QObject *parent = nullptr);

    QList<NetworkPlace> networkPlaces();
    bool addNetworkPlace(const NetworkPlace &place);
    void removeNetworkPlace(const NetworkPlace &place);
    void updateNetworkPlace(const NetworkPlace &place);

signals:
    void networkPlaceAdded(const FlyFM::NetworkPlace &place);
    void networkPlaceRemoved(const FlyFM::NetworkPlace &place);
    void networkPlaceUpdated(const FlyFM::NetworkPlace &place);

private slots:
    void slotNetworkPlaceAdded(const FlyFM::NetworkPlace &place);
    void slotNetworkPlaceRemoved(const FlyFM::NetworkPlace &place);
    void slotNetworkPlaceUpdated(const FlyFM::NetworkPlace &place);

private:
    QWeakPointer<QDBusInterface> m_interface;

    QList<NetworkPlace> m_places;
    bool m_cached;
};

} // namespace FlyFM

#endif // FLYFM_NETWORKPLACESMANAGERPROXY_H
